"use strict";

function invoke(fn) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return {
    type: "invoke",
    fn: fn,
    args: args,
    useCallback: false
  };
}

function invokeCtx(fn, ctx) {
  for (var _len2 = arguments.length, args = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
    args[_key2 - 2] = arguments[_key2];
  }

  return {
    type: "invoke",
    fn: fn,
    args: args,
    useCallback: false,
    ctx: ctx
  };
}

function invokeCallback(fn) {
  for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
    args[_key3 - 1] = arguments[_key3];
  }

  return {
    type: "invoke",
    fn: fn,
    args: args,
    useCallback: true
  };
}

function invokeNode() {
  return invokeCallback.apply(null, arguments);
}

function invokeCallbackCtx(fn, ctx) {
  for (var _len4 = arguments.length, args = Array(_len4 > 2 ? _len4 - 2 : 0), _key4 = 2; _key4 < _len4; _key4++) {
    args[_key4 - 2] = arguments[_key4];
  }

  return {
    type: "invoke",
    fn: fn,
    args: args,
    useCallback: true,
    ctx: ctx
  };
}

function invokeNodeCtx() {
  return invokeCallbackCtx.apply(null, arguments);
}

module.exports = {
  invoke: invoke,
  invokeCtx: invokeCtx,
  invokeCallback: invokeCallback,
  invokeNode: invokeNode,
  invokeCallbackCtx: invokeCallbackCtx,
  invokeNodeCtx: invokeNodeCtx
};
//# sourceMappingURL=invoke.js.map