"use strict";

var polls = {};

var _require = require("./guid"),
    guid = _require.guid;

function poll(_ref, _ref2) {
  var fn = _ref.fn,
      ctx = _ref.ctx,
      _ref$interval = _ref.interval,
      interval = _ref$interval === undefined ? 1000 : _ref$interval,
      tryCount = _ref.tryCount;
  var call = _ref2.call,
      config = _ref2.config,
      handlers = _ref2.handlers;

  var count = 0;
  var id = guid();
  return new Promise(function (resolve, reject) {
    function doPoll(ctx2) {
      if (tryCount && count >= tryCount) return resolve(ctx2);
      if (ctx2.done === true) return resolve(ctx2);
      polls[id] = setTimeout(function () {
        try {
          call(config, handlers, fn, ctx2, id).then(function (updatedContext) {
            count++;
            if (!updatedContext) {
              return reject(new Error("The context must be returned from a polling function."));
            }
            if (polls[id] === undefined) return resolve(updatedContext);
            doPoll(updatedContext);
          }).catch(reject);
        } catch (e) {
          reject(e);
        }
      }, interval);
    }

    doPoll(ctx);
  });
}

function clearPoll(_ref3) {
  var id = _ref3.id;

  clearTimeout(polls[id]);
  delete polls[id];
}

module.exports = {
  poll: poll,
  clearPoll: clearPoll
};
//# sourceMappingURL=poll.js.map